import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle

pBridge = App.g_kSetManager.GetSet('bridge')
g_pKiska = App.CharacterClass_GetObject(pBridge, 'Helm')
pKiskaMenu = Bridge.BridgeUtils.GetBridgeMenu('Helm')
ET_COLLISION_COURSE = App.Mission_GetNextEventType()

def CollisionCourse(pObject, pEvent):
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pFriendlies	= pMission.GetFriendlyGroup()
	pPlayer	= MissionLib.GetPlayer()
	pTarget	= pPlayer.GetTarget()
	pTargetattr	= App.ShipClass_Cast(pTarget)

	if not pTarget:
		print("No Target")
		return

	# Play the sound
	pSound = App.TGSound_Create("sfx/Interface/new_game.wav", "AS_Sound", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("AS_Sound")
	
	# Max Power to Engines
	import Bridge.EngineerMenuHandlers
	Bridge.EngineerMenuHandlers.SetPowerToSubsystem(pPlayer.GetImpulseEngineSubsystem(), 1.5)
	
	# Ram
	pPlayer.SetAI(CreateAI(pPlayer, pTarget))
	

	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, pHelm.GetCharacterName() + "Yes" + str(App.g_kSystemWrapper.GetRandomNumber(4)+1), "Captain", 1))
	pSequence.Play()

event = Lib.Ambiguity.getEvent(ET_COLLISION_COURSE)
g_pKiska.AddPythonFuncHandlerForInstance(event, __name__ + ".CollisionCourse")
pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("CollisionCourse"), event, 0, g_pKiska) #g_pKiska here, not g_Kiska
pKiskaMenu.PrependChild(pButton)

# From Maelstrom/E7M2/VorchaRamAI.py
def CreateAI(pShip, pTarget):
	#########################################
	# Creating PlainAI Ram_Warbird at (209, 81)
	pRam_Warbird = App.PlainAI_Create(pShip, "Ram_Warbird")
	pRam_Warbird.SetScriptModule("Ram")
	pRam_Warbird.SetInterruptable(1)
	pScript = pRam_Warbird.GetScriptInstance()
	pScript.SetTargetObjectName(pTarget.GetName())
	pScript.SetMaximumSpeed(9)
	# Done creating PlainAI Ram_Warbird
	#########################################
	#########################################
	# Creating PriorityListAI PriorityList at (50, 50)
	pPriorityList = App.PriorityListAI_Create(pShip, "PriorityList")
	pPriorityList.SetInterruptable(1)
	# SeqBlock is at (149, 57)
	pPriorityList.AddAI(pRam_Warbird, 1)
	# Done creating PriorityListAI PriorityList
	#########################################
	return pPriorityList

